unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CommCtrl, StdCtrls, Buttons, ExtCtrls, DateUtils, Math;

type
  PIConArray = ^TIConArray;
  TIConArray = Array of TRect;
  TUseDate = Record
    Disp :Boolean;
    Day  :Integer;
    Value:String;
  end;
  TForm1 = class(TForm)
    MBtn: TSpeedButton;
    CBtn: TSpeedButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure CBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel28Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure WMMove(var Msg:TMessage);message WM_MOVE;
    procedure SetRgnRec;
    procedure DrawPaint;
    procedure DrawDate(Const Value:TDateTime);
  end;

function GetIconRect(Const R:PIConArray):Integer;

var
  Form1: TForm1;
  fRun : Boolean = False;
  fDat : Array[0..41]of TUseDate;

implementation

{$R *.dfm}

function GetIconRect(Const R:PIConArray):Integer;
var
  dc,hid :THandle;
  pid,tmp:DWORD;
  fR     :PRect;
  dR     :TRect;
  i      :Integer;
begin
  Result:=0;
  if(R=nil)then Exit;
  dc:=GetWindow(GetWindow(FindWindow('Progman',nil),GW_CHILD),GW_CHILD);
  Result:=ListView_GetItemCount(dc);
  SetLength(R^,Result);
  GetWindowThreadProcessId(dc,pid);
  hid:=OpenProcess(PROCESS_ALL_ACCESS,False,pid);
  fR:=VirtualAllocEx(hid,nil,Sizeof(TRect),MEM_COMMIT	or MEM_RESERVE,PAGE_EXECUTE_READWRITE);
  for i:=0 to Result-1 do begin
    dR.Left:=LVIR_SELECTBOUNDS;
    WriteProcessMemory(hid,fR,@dR,Sizeof(TRect),tmp);
    if(SendMessage(dc,LVM_GETITEMRECT,i,Integer(fR))<>0)then begin
      ReadProcessMemory(hid,fR,@dR,Sizeof(TRect),Tmp);
      R^[i]:=dR;
    end;
  end;
  VirtualFreeEx(hid,fR,Sizeof(TRect),MEM_RELEASE);
  CloseHandle(hid);
end;

procedure TForm1.WMMove(var Msg:TMessage);
begin
  if Not fRun then Abort;
  DrawPaint;
  MBtn.Invalidate;
  CBtn.Invalidate;
  SetRgnRec;
end;

procedure TForm1.SetRgnRec;
var
  hg,tmp:HRGN;
  iCount:Integer;
  RAry  :PIConArray;
  i     :Integer;
  p1,p2 :TPoint;
begin
  New(RAry);
  hg:=CreateRectRgn(0,0,Width,Height);
  iCount:=GetIconRect(RAry);
  for i:=0 to iCount-1 do
    with RAry^[i] do begin
      p1:=ScreenToClient(TopLeft);
      p2:=ScreenToClient(BottomRight);
      tmp:=CreateRectRgn(p1.X,p1.Y,p2.X,p2.Y);
      CombineRgn(hg,hg,tmp,RGN_XOR);
      DeleteObject(tmp);
    end;
  SetWindowRgn(Handle,hg,True);
  DeleteObject(hg);
  Dispose(RAry);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if(Not MBtn.Down)then abort;
  ReleaseCapture;
  perform(WM_SysCommand, SC_MOVE or 2, 0);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  DrawPaint;
end;

procedure TForm1.CBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  dc:THandle;
begin
  fRun:=True;
  dc:=GetWindow(GetWindow(FindWindow('Progman',nil),GW_CHILD),GW_CHILD);
  Windows.SetParent(Handle,dc);
end;

procedure TForm1.DrawDate(Const Value:TDateTime);
Const
  fAryStr:Array[0..6]of String = ('P','P@','PG','PT','P|','P','P');
  fAryPos:Array[0..6]of Integer= (3,87,171,255,339,423,508);
  fAryTop:Array[0..5]of Integer= (60,124,188,252,316,380);
  fAryCol:Array[0..6]of TColor = (clRed,clBlue,clBlue,clBlue,clBlue,clBlue,clGreen);
var
  i,j,L,r :Integer;
  fday    :TDateTime;
  Bo      :Boolean;
  procedure DrawRect(Const x,y,w,h:Integer;Const Str:String;Const fCol:TColor;Const fBox:Boolean=True;Const fDw:Integer=0;Const fAp:Boolean=True);
  var
    tw,th,tx,ty:Integer;
  begin
    if(fAp)then Canvas.Brush.Style:=bsClear
           else Canvas.Brush.Style:=bsSolid;
    if(fBox)then begin
      Canvas.Pen.Color:=fCol;
      Canvas.Rectangle(x,y,x+w,y+h);
    end;
    tw:=Canvas.TextWidth(Str);
    th:=Canvas.TextHeight(Str);
    tx:=x+(w-tw)div 2;
    ty:=y+(h-th)div 2;
    Case fdw of
      0:begin
          tx:=x+5;
          ty:=y+5;
        end;
    end;
    Canvas.Font.Color:=clWhite;
    Canvas.TextOut(tx+1,ty+1,Str);
    Canvas.Font.Color:=fCol;
    Canvas.TextOut(tx  ,ty  ,Str);
  end;
begin
  Canvas.Pen.Color:=clBlue;
  Canvas.Brush.Style:=bsClear;
  DrawRect(3  ,4 ,166,25,FormatDateTime('yyyy~mmdd',Value),clRed,False);
  for i:=0 to 6 do DrawRect(fAryPos[i],32,81,25,fAryStr[i],fAryCol[i],False);
  fDay:=IncDay(Value,1-DayOf(Value)); //D1
  j   :=DayOfTheWeek(fDay);           //D1PX
  L   :=DayOf(IncMonth(fDay)-fDay);   //Do릳X
  for i:=j to Min(j+L,41) do begin
    Bo:=True;
    r:=i-j+1;
    if(r=DayOf(Value))then Bo:=False;
    DrawRect(fAryPos[i mod 7],fAryTop[i div 7],81,61,IntToStr(r),fAryCol[i mod 7],True,0,Bo);
  end;
end;

procedure TForm1.DrawPaint;
begin
  PaintDesktop(Canvas.Handle);
  Canvas.Pen.Color:=clBlack;
  Canvas.Brush.Style:=bsClear;
  Canvas.Rectangle(0,0,Width,Height);
  DrawDate(Now);
end;

procedure TForm1.Panel28Click(Sender: TObject);
var
  d:tdatetime;
  i:Integer;
begin
  d:=now;
  d:=incmonth(d,-3);
  //
  d:=IncDay(d,1-Dayof(d));
  i:=DayOf(IncMonth(d)-d)+1;
  showmessage(inttostr(Monthof(d))+'A'+inttostr(i)+'');
  exit;
  d:=now;
  showmessage(formatdatetime('yyyy,mm,dd',d));
  d:=IncMonth(d,-1);
//  d:=RecodeMonth(d,1);
  showmessage(formatdatetime('yyyy,mm,dd',d));
 // Showmessage(inttostr(DayOfTheWeek((Now-DayOf(Now)+1))));
end;

end.
